//$Id: form.h,v 1.15 2002/01/01 21:23:40 cactus Exp $ -*- c++ -*-

/* Guikachu Copyright (C) 2001-2002 RDI Gerg <cactus@cactus.rulez.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef GUIKACHU_FORM_EDITOR_FORM_H
#define GUIKACHU_FORM_EDITOR_FORM_H

namespace Guikachu
{
    namespace Widgets
    {
	class Form;
    }
}

#include <string>
#include <gnome--/canvas-group.h>
#include <sigc++/object.h>

#include "form-res.h"
#include "form-editor/form-element.h"
#include "form-editor/form-canvas.h"
#include "form-editor/form-prop.h"

namespace Guikachu
{
    namespace Widgets
    {
	class Form: public FormElement,
		    public SigC::Object
	{		
	    typedef std::map<Gnome::CanvasGroup *,
		GUI::FormEditor::FormCanvasItem*> canvas_item_map_t;
	    
	    Resources::Form *res;
	    
	    mutable GUI::FormEditor::FormProperties *editor;
	    mutable canvas_item_map_t                canvas_items;
	    
	public:
	    Form (Resources::Form *res);
	    ~Form ();
	    
	    // FormElement methods
	    int get_x () const { return res->x; };
	    int get_y () const { return res->y; };
	    
	    Gtk::Widget                     *get_editor      ();
	    GUI::FormEditor::FormCanvasItem *get_canvas_item (Gnome::CanvasGroup *parent_group);

	    Resources::Form *get_resource () const { return res; };
	    
	    SigC::Signal1<void, bool> selected;
	    SigC::Signal0<void>       request_edit;
	};
    }
}

#endif /* !GUIKACHU_FORM_EDITOR_FORM_H */
